Moved local configuration sourcing to occur after global variables are defined.
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=1.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
20 #
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs
23 #
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
26 #
27
28 ##############################################################################################
29 # Global Variables
30 ##############################################################################################
31 typeset cmd="$0 $*"
32 typeset dvdname=""
33 typeset debug=""
34 typeset dest=""
35 typeset isofile=""
36 typeset vobfile=""
37 typeset dvdpath=""
38 typeset aspect=""
39 typeset SCALE=""
40 typeset CROP=""
41 typeset profile="xvidvhq"
42 typeset extension=""
43 typeset -i force_onepass_mode=0
44 typeset -i eject_disk=1
45 typeset -i keep_isofile=0
46 typeset -i keep_vobfile=0
47 typeset -i keep_dvdfolder=0
48 typeset -i keep_intermediate_files=0
49 typeset -i make_final_dest_vob=0
50 typeset -i make_final_dest_iso=0
51 typeset -i make_final_dest_folder=0
52 typeset -i make_final_dest_comp=0
53 typeset -i errors=0
54 typeset -i show_usage=0
55 typeset -i mirror_mode=0
56 typeset -i target_bitrate=2000
57 typeset -i target_size=0
58 typeset -i audio_2ch=0
59 typeset -i invalid_feature_title=0
60 typeset -i feature_title_override=0
61 typeset -i mplayer_dumpstream_incompatibility=0
62
63 ##############################################################################
64 # Local Machine Settings:
65 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
66 # and the local conf file created by each local machine (rip_dvd.conf)
67 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
68 # This will allow you to override all the default values to meet your needs
69 # in a way that won't get clobbered when you pull updates from my GIT repo.
70 ##############################################################################
71 config="${0%/*}/rip_dvd.conf"
72 [ -e "${config}.dist" ] && . ${config}.dist
73 [ -e "${config}" ] && . ${config}
74
75 ##############################################################################################
76 # Command line processing
77 ##############################################################################################
78 while (($#)) && getopts 12mvifkxht:n:d:b:s:t:a:p:e:j: opt "$@"
79 do
80     case $opt in
81         (n)     dvdname=$OPTARG;;
82         (d)     dest=$OPTARG;;
83         (b)     target_bitrate=$OPTARG;;
84         (s)     target_size=$OPTARG;;
85         (2)     audio_2ch=1;;
86         (1)     force_onepass_mode=1;;
87         (v)     make_final_dest_vob=1;;
88         (i)     make_final_dest_iso=1;;
89         (f)     make_final_dest_folder=1;; 
90         (x)     make_final_dest_comp=1;;
91         (m)     mirror_mode=1;;
92         (k)     keep_intermediate_files=1;;
93         (t)     feature_title_override=$OPTARG;;
94         (a)     aspect=$OPTARG;;
95         (p)     profile=$OPTARG;;
96         (e)     extension=$OPTARG;;
97         (j)     eject_disk=$OPTARG;;
98         (w)     set -$opt;;
99         (h)     show_usage=1;;
100         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
101         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
102     esac
103 done
104
105 shift $((OPTIND-1))
106
107 function usage() {
108     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
109     echo >&2 "Revision $REV"
110     echo >&2 "Options:"
111     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
112     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
113     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
114     echo >&2 "                 2) If dvdname exists in $tmpdir, it will be ripped as a DVD instead of $dev"
115     echo >&2 "                 3) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
116     echo >&2 "                 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
117     echo >&2 "                 5) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
118     echo >&2 "   -p <profile>  Specify which encoding profile to use in -x mode as shown below:"
119     echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding (default)"
120     echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding"
121     echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
122     #echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
123     #echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
124     #echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
125     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
126     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
127     echo >&2 "   -e <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
128     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
129     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
130     echo >&2 "                 The default operation is non-mirror mode where only the main"
131     echo >&2 "                 feature title will be ripped."
132     echo >&2 "   -v            Make the final image a DVD VOB file"
133     echo >&2 "   -i            Make the final image a DVD ISO file"
134     echo >&2 "   -f            Make the final image a DVD folder"
135     echo >&2 "   -x            Make the final image a compressed file based on your profile selection"
136     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
137     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
138     echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
139     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
140     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
141     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
142     echo >&2 "   -j <n>        Eject the disk:"
143     echo >&2 "                 - 0 = do not eject the disk"
144     echo >&2 "                 - 1 = eject after the entire script is done (default)"
145     echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
146     echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
147     echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
148     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
149     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
150     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
151     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
152     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
153     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
154     echo >&2 ""
155     exit 2
156 }
157
158 if (($errors)) || (($show_usage))
159 then
160   usage
161 fi
162
163 # Sanity Check - Command Line Options 
164 if [ "$dest" == "" ]; then
165   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
166   usage
167 fi
168
169 if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
170   echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
171   usage
172 fi
173
174 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
175   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
176   usage
177 fi
178
179 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
180    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
181   echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
182   usage
183 fi
184
185 if [ $mirror_mode -eq 1 ]; then
186   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
187      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
188     echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
189     usage
190   fi
191 fi
192
193 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
194 if [ "$aspect" != "" ]; then
195   echo "$aspect" | grep -q "x"
196   if [ $? == 0 ]; then
197     echo "-E- You must specify the aspect option with a value whose format is W:H"
198     exit 1
199   fi
200   echo "$aspect" | grep -q ":"
201   if [ $? != 0 ]; then
202     SCALE=",scale -zoom -sws 9 -xy $aspect"
203   else
204     SCALE=",scale=$aspect"
205   fi
206 fi
207
208
209 # Sanity Check - Key executables
210 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
211 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
212 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
213 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
214 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
215 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
216 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
217 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
218
219 ##############################################################################################
220
221 typeset -i ripdvd
222 if [ -z "$dvdname" ]; then
223   # make sure the DVD device is accessible
224   volname $dev > /dev/null 2>&1
225   if [ $? != 0 ]; then
226     echo "-E- Can't access the DVD device $dev"
227     exit 1
228   fi
229   # now capture the volume name from the device
230   dvdname=`volname $dev | awk '{ print $1 }'`
231   ripdvd=1
232 else 
233   # check to see if dvdname is a full path to a real directory
234   # if it is, set dvdname and dvdpath appropriately
235   if [ -d "$dvdname" ]; then
236     dvdpath="$dvdname"
237     dvdname=`basename "$dvdname"`
238     keep_dvdfolder=1
239     if [ -z "$dvdname" ]; then
240      echo "-E- Unable to extract dvdname from path: $dvdpath"
241      exit 1
242     fi
243     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
244       echo "-E- You must supply a full path to a valid DVD folder with this option"
245       exit 1
246     fi
247   fi
248
249   # Check to see if dvdname is a full path to a file
250   if [ -f "$dvdname" ]; then
251     valid_file=0
252
253     # check to see if dvdname is a full path to an MPG2 (VOB) file
254     # if it is, set dvdname and vobfile appropriately
255     file "$dvdname" | grep -q "MPEG"
256     if [ $? == 0 ]; then
257       # It is a valid MPEG2 file, now strip the extension off our dvdname
258       vobfile="$dvdname"
259       dvdname=`basename "$dvdname"`
260       dvdname=${dvdname%.[^.]*}
261       keep_vobfile=1
262       valid_file=1
263     fi
264
265     # check to see if dvdname is a full path to an ISO file
266     # if it is, set dvdname and isofile appropriately
267     file "$dvdname" | grep -q -e "ISO" -e "UDF"
268     if [ $? == 0 ]; then
269       # It is a valid ISO file, now strip the extension off our dvdname
270       isofile="$dvdname"
271       dvdname=`basename "$dvdname"`
272       dvdname=${dvdname%.[^.]*}
273       keep_isofile=1
274       valid_file=1
275     fi    
276
277     # If we didn't find a handler for the file above, complain
278     if [ $valid_file -eq 0 ]; then
279       echo "-E- Unsupported file type: $vobfile"
280       exit 1
281     fi
282   fi
283   ripdvd=0
284   # Since we aren't ripping a DVD disk, don't eject anything
285   eject_disk=0
286 fi
287
288 # remove bad characters from the dvdname
289 dvdname=${dvdname%.} # remove trailing '.' character
290
291 # add the suffix extension to the end of the dvdname
292 dvdname=$dvdname$extension
293
294 # make a "safe" dvdname (remove special characters)
295 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
296
297 # Make sure we have a non-empty dvdname
298 if [ -z "$dvdname" ]; then
299   echo "-E- unable to determine dvdname"
300   exit 1
301 fi
302
303 # make sure our vobfile value is set
304 if [ -z "$vobfile" ]; then
305   vobfile="$dest/$dvdname.VOB"
306 fi
307
308 # set up some variables to hold various logfiles
309 logfile="$logdir/$dvdname.log"
310 passlogfile="$tmpdir/$safedvdname.log"
311 ddrescuelog=`tempfile`
312 dvdauthorlog=`tempfile`
313 encodelog=`tempfile`
314 dumplog=`tempfile`
315
316 # create the tmpdir if it doesn't already exist
317 if [ ! -d "$tmpdir" ]; then
318   mkdir -p "$tmpdir"
319   if [ $? != 0 ]; then
320     echo "-E- Unable to create the tmpdir: $tmpdir"
321     exit 1
322   fi
323 fi
324
325 # create the logdir if it doesn't already exist
326 if [ ! -d "$logdir" ]; then
327   mkdir -p "$logdir"
328   if [ $? != 0 ]; then
329     echo "-E- Unable to create the logdir: $logdir"
330     exit 1
331   fi
332 fi
333
334 ##############################################################################################
335 # cleanup functions
336 ##############################################################################################
337 cleanup() { 
338   if [ $keep_intermediate_files -eq 0 ]; then
339     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
340     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
341     [[ -e "$encodelog" ]] && rm -f "$encodelog"
342     [[ -e "$dumplog" ]] && rm -f "$dumplog"
343   else
344     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
345     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
346     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
347     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
348   fi
349   echo ""
350 }
351
352 fatal_and_exit() {
353   if [[ -z "$1" ]]; then
354     msg="-E- control-c killed us"
355   else
356     msg=$1
357   fi
358   echo -e 2>&1 "$msg" | tee -a "$logfile"
359   if [[ -n "$mailto" ]]; then
360     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
361   fi
362   keep_intermediate_files=1
363   exit 1
364 }
365
366 # Call our cleanup functions on INT and EXIT signals
367 trap fatal_and_exit INT
368 trap cleanup EXIT
369
370 ##############################################################################################
371 # processing functions
372 ##############################################################################################
373
374 # encode the vob file into a compressed file format
375 function encode_vob_file {
376
377   # Set a variable that we will use later to determine if we found a handler for $profile or not
378   typeset -i found_profile=0
379
380   # For a given profile, to override the 2 pass behavior to be single pass,
381   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
382   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
383   PASSES="1 2"
384
385   # Declare our default 2 pass variables
386   passlogfile_opt="-passlogfile $passlogfile"
387   pass_opt="pass=%PASS"
388
389   # Check the global force_onepass_mode. If it is set, change our variables appropriately
390   # to force 1-pass encoding across all profiles.
391   if [ $force_onepass_mode -eq 1 ]; then
392     PASSES="2"
393     passlogfile_opt=""
394     pass_opt=""    
395   fi
396
397   # XVID profile
398   if [ "$profile" == "xvid" ] || [ "$profile" == "xvidhq" ] || [ "$profile" == "xvidvhq" ]; then
399     found_profile=1
400     final_output_file="$dest/$dvdname.avi"
401     mencoder_general_opts="$lang_opts $passlogfile_opt"
402     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
403     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
404     mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
405
406     # Very High Quality (16fps)
407     if [ "$profile" == "xvidvhq" ]; then
408       video_encoder_opts[0]="bitrate=$target_bitrate"
409       video_encoder_opts[1]="threads=$mencoder_threads"
410       video_encoder_opts[2]="chroma_opt"
411       video_encoder_opts[3]="vhq=4"
412       video_encoder_opts[4]="bvhq=1"
413       video_encoder_opts[5]="quant_type=mpeg"
414       video_encoder_opts[6]="autoaspect"
415     fi
416     # High Quality (20fps)
417     if [ "$profile" == "xvidhq" ]; then
418       video_encoder_opts[0]="bitrate=$target_bitrate"
419       video_encoder_opts[1]="threads=$mencoder_threads"
420       video_encoder_opts[2]="chroma_opt"
421       video_encoder_opts[3]="vhq=2"
422       video_encoder_opts[4]="bvhq=1"
423       video_encoder_opts[5]="quant_type=mpeg"
424       video_encoder_opts[6]="autoaspect"
425     fi
426     # Fast (28fps)
427     if [ "$profile" == "xvid" ]; then
428       video_encoder_opts[0]="bitrate=$target_bitrate"
429       video_encoder_opts[1]="threads=$mencoder_threads"
430       video_encoder_opts[2]="vhq=0"
431       video_encoder_opts[3]="turbo"
432       video_encoder_opts[4]="autoaspect"
433     fi
434
435     for OPTS in "${video_encoder_opts[@]}"; do 
436       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
437     done
438
439     if [ $audio_2ch -eq 0 ]; then
440       # These options produce good 6 channel audio for linux and windows
441       mencoder_audio_opts="-oac copy"
442       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
443       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
444       mencoder_audioch_opts[1]="-af channels=6"
445       mencoder_audioch_opts[2]=""
446     else
447       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
448       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
449       mencoder_audioch_opts[0]=""
450     fi
451  
452   fi
453
454   # MP4 encoding profiles
455   # These are currently in BETA. They don't work that great. A new recipe is needed, for the audio.
456   if [ "$profile" == "mp4" ] || [ "$profile" == "mp4hq" ] || [ "$profile" == "mp4vhq" ]; then
457     found_profile=1
458     final_output_file="$dest/$dvdname.mp4"
459     mencoder_general_opts="$lang_opts $passlogfile_opt"
460     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
461     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
462     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
463
464     # Very High Quality (6fps)
465     if [ "$profile" == "mp4vhq" ]; then
466       video_encoder_opts[0]="bitrate=$target_bitrate"
467       video_encoder_opts[1]="threads=$mencoder_threads"
468       video_encoder_opts[2]="subq=6"
469       video_encoder_opts[3]="frameref=5"
470       video_encoder_opts[4]="bframes=3"
471       video_encoder_opts[5]="8x8dct"
472       video_encoder_opts[6]="me=umh"
473       video_encoder_opts[7]="b_pyramid"
474       video_encoder_opts[8]="weight_b"
475       video_encoder_opts[9]="partitions=all" 
476     fi
477     # High Quality (13fps)
478     if [ "$profile" == "mp4hq" ]; then
479       video_encoder_opts[0]="bitrate=$target_bitrate"
480       video_encoder_opts[1]="threads=$mencoder_threads"
481       video_encoder_opts[2]="subq=5"
482       video_encoder_opts[3]="frameref=2"
483       video_encoder_opts[4]="bframes=3"
484       video_encoder_opts[5]="8x8dct"
485       video_encoder_opts[6]="b_pyramid"
486       video_encoder_opts[7]="weight_b"
487     fi
488     # Fast (17fps)
489     if [ "$profile" == "mp4" ]; then
490       video_encoder_opts[0]="bitrate=$target_bitrate"
491       video_encoder_opts[1]="threads=$mencoder_threads"
492       video_encoder_opts[2]="subq=4"
493       video_encoder_opts[3]="bframes=2"
494       video_encoder_opts[4]="b_pyramid"
495       video_encoder_opts[5]="weight_b"
496     fi
497
498     for OPTS in "${video_encoder_opts[@]}"; do
499       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
500     done
501
502     if [ $audio_2ch -eq 0 ]; then
503       # These options produce good 6 channel audio for linux and windows
504       #mencoder_audio_opts="-oac copy"
505       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
506       #mencoder_audioch_opts[0]="-channels 6 -af channels=6"
507       #mencoder_audioch_opts[1]="-af channels=6"
508       #mencoder_audioch_opts[2]=""
509       mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
510       mencoder_audioch_opts[0]="-channels 6 -srate 48000"
511     else
512       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
513       #mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
514       #mencoder_audioch_opts[0]=""
515       mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
516       mencoder_audioch_opts[0]="-channels 2 -srate 48000"
517     fi
518
519   fi
520
521   # iphone and ipod MP4 profiles
522   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
523     found_profile=1
524     if [ "$profile" == "iphone" ]; then
525       # SCALE: 480x320
526       # scale width to 480, set height appropriately, but keep a multiple of 16
527       #SCALE=",scale=480:-10"
528       # scale the video down however far is necessary to fit in 480x320
529       SCALE=",dsize=480:320:0,scale=-8:-8"
530     else
531       # SCALE: 320x240
532       # scale width to 320, set height appropriately, but keep a multiple of 16
533       #SCALE=",scale=320:-10"
534       # scale the video down however far is necessary to fit in 320x240
535       SCALE=",dsize=320:240:0,scale=-8:-8"
536     fi
537     final_output_file="$dest/$dvdname.mp4"
538     mencoder_general_opts="$lang_opts $passlogfile_opt"
539     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
540     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
541     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
542     video_encoder_opts[0]="bitrate=$target_bitrate"
543     video_encoder_opts[1]="threads=$mencoder_threads"
544     video_encoder_opts[2]="vbv_maxrate=1500"
545     video_encoder_opts[3]="vbv_bufsize=2000"
546     video_encoder_opts[4]="nocabac"
547     video_encoder_opts[5]="me=umh"
548     video_encoder_opts[6]="subq=6"
549     video_encoder_opts[7]="frameref=6"
550     video_encoder_opts[8]="trellis=1"
551     video_encoder_opts[9]="level_idc=30"
552     video_encoder_opts[10]="global_header"
553     video_encoder_opts[11]="bframes=0"
554     video_encoder_opts[12]="partitions=all"
555     for OPTS in "${video_encoder_opts[@]}"; do 
556       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
557     done
558
559     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
560     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
561   fi
562
563   if [ $found_profile -eq 0 ]; then
564     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
565   fi
566
567   # Do not edit this line. $mencoder_video_encoder_opts must be last
568   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
569   mencoder_retval=0
570
571   for PASS in $PASSES
572   do 
573     # Set some options based on which pass we are in
574     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
575     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
576     [ $PASS -eq 1 ] && output_file="/dev/null"
577     [ $PASS -eq 2 ] && output_file="$final_output_file"
578   
579     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
580     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
581     do
582       echo -e "   Encoding pass $PASS"
583       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
584       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
585       mencoder_retval=$? 
586       grep -q "\[channels\] Invalid" $encodelog
587       if [ $? != 0 ]; then          
588         break;
589       else
590         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
591       fi
592     done
593       
594     if [ $mencoder_retval != 0 ]; then
595       fatal_and_exit "-E- Unhandled mencoder error"
596     fi
597
598     # Concatenate the encode log to our main log file, greping out unwanted lines
599     cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
600
601   done
602 }
603
604 function make_dvd_iso_image {
605
606   isofile="$1"
607
608   # check to see if we have a dvdpath to rip from instead of $dev
609   if [ -z "$dvdpath" ]; then
610     # load the CSS codes in the DVD drive 
611     lsdvd $dev >> "$logfile"
612     if [ $? != 0 ]; then
613       fatal_and_exit "-E- lsdvd $dev failed" 
614     fi
615
616     # read the DVD, ignoring/skipping CRC errors
617     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
618     if [ $? != 0 ]; then
619       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
620     fi
621     cat "$ddrescuelog" >> "$logfile"
622   else
623     # rip from a path instead
624     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
625   fi
626 }
627
628 function make_dvd_iso_image_from_folder {
629   
630   src="$1"
631   dst="$2"
632   handle_error=$3
633   
634   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
635
636   # make an iso image out of our directory
637   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
638   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
639
640   # set the audio languages from the iso if it exists and is non-zero in size
641   if [ -s "$dst" ]; then
642     get_feature_title "$dst"
643     get_audio_id_from_iso "$dst"
644   fi
645
646   # make sure we were able to create the iso image from the folder given to us
647   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
648     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
649     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
650     # remove the bad iso file
651     [[ -e "$dst" ]] && rm -f "$dst"
652     # get the feature title from the DVD folder
653     get_feature_title "$dvdpath"
654     # create our main VOB file from the ISO
655     create_main_vob_with_mplayer "$dvdpath" 
656     # get our audio id from the VOB file
657     get_audio_id_from_vob "$vobfile"
658   fi
659 }
660
661 function make_dvdbackup_folder_image {
662   # extract the feature title from the DVD image
663   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
664   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
665   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
666   if [ $? != 0 ]; then
667     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
668   fi
669 }
670
671 function make_dvdauthor_folder_image {
672   # create a new DVD video of the feature title
673   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
674   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
675   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
676   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
677
678   # There is a chance that dvdauthor won't like some of the VOBs.
679   # We can't tell ahead of time which ones it will choke on. 
680   # So, we need to run it over and over again until it can process
681   # all the VOBs. If it can't handle one of them, run it through
682   # mencoder to fix it and try again. These errors are typically
683   # present due to the copy protection that ddrescue removed.
684   grep -q "SCR moves" $dvdauthorlog
685   while [ $? == 0 ]; do
686     # fix bad vobs that get the "SCR moves backwards" error:
687     #  STAT: Processing VTS_01_0.VOB...
688     #  ERR:  SCR moves backwards, remultiplex input.
689     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
690     if [[ ! -f "$badvob" ]]; then
691       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
692     fi
693     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
694     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
695     mv -f $badvob.fixed $badvob
696     echo "-> Creating DVD video $dest/$dvdname"
697     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
698     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
699     grep -q "SCR moves" $dvdauthorlog
700   done
701 }
702
703 function get_feature_title {
704   source="$1"
705   # if a feature title was given on the command line, use it
706   if [ $feature_title_override -ne 0 ]; then
707     feature_title=$feature_title_override
708     return 0
709   fi
710   # otherwise, use lsdvd to figure it out
711   if [ $ripdvd -eq 1 ]; then
712     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
713   else 
714     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
715   fi
716 }
717
718 function create_main_vob_with_cat {
719   # cd to the feature title DVD folder
720   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
721   if [ $? != 0 ]; then
722     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
723   fi
724
725   # concatenate all the VOBs together into 1 giant VOB
726   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
727   cat $vobs > "$tmpdir/$dvdname.VOB"
728
729   # cd back to the dir we started from
730   popd > /dev/null 2>&1
731 }
732
733 function create_main_vob_with_mplayer {
734
735   # argument processing  
736   source="$1"
737   remove_dumplog=$2
738
739   # make sure we have a valid feature title
740   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
741     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
742   fi
743
744   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
745   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
746     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
747     msg="$msg We also detected another condition that requires us to use dumpstream. "
748     msg="$msg\n    Unable to rip this DVD in the mode you requested."
749     fatal_and_exit "$msg"
750   fi
751
752   # use mplayer to create the main VOB file
753   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
754   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
755   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
756   if [ $? != 0 ]; then
757     cat $dumplog | grep -v "^A:" >> "$logfile"
758     fatal_and_exit "-E- Mplayer Failed"
759   fi
760   cat $dumplog | grep -v "^A:" >> "$logfile"
761   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
762 }
763
764 function get_audio_id_from_iso {
765   # Adjust our audio ID to find the english audio stream
766   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
767   iso="$1"
768   aidcheck=`tempfile`
769   aid=128
770   mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
771   grep -q "aid: $aid" $aidcheck
772   while [ $? == 1 ] && [ $aid -lt 159 ]; do
773     (( aid = aid + 1 ))
774     grep -q "aid: $aid" $aidcheck
775   done
776   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
777   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
778   # mencoder default DVD audio track language selection (english)
779   lang_opts="-aid $aid -alang en"
780 }
781
782 function get_crop_from_iso { 
783   FRAMES=10000
784   echo "-> Detecting black frame border crop value from ISO file"
785   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
786   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
787   [[ -e "md5sums" ]] && rm -f "md5sums"
788   CROP=`cat $dumplog | grep CROP | tail -1`
789   echo "   Found crop value of $CROP" >> "$logfile"
790   CROP=${CROP#* crop=}
791   CROP=${CROP%%\).*}
792   typeset -i CROPCHECK
793   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
794   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
795   if [ -z "$CROP" ]; then
796     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
797     return
798   fi
799   if [ $CROPCHECK -lt 0 ]; then 
800     CROP=""
801   else 
802     CROP=",crop=$CROP"
803   fi
804   echo "   Setting mencoder crop filter to: $CROP"
805 }
806
807 function get_crop_from_vob { 
808   FRAMES=10000
809   echo "-> Detecting black frame border crop value from VOB file"
810   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
811   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
812   [[ -e "md5sums" ]] && rm -f "md5sums"
813   CROP=`cat $dumplog | grep CROP | tail -1`
814   echo "   Found crop value of $CROP" >> "$logfile"
815   CROP=${CROP#* crop=}
816   CROP=${CROP%%\).*}
817   typeset -i CROPCHECK
818   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
819   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
820   if [ -z "$CROP" ]; then
821     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
822     return
823   fi
824   if [ $CROPCHECK -lt 0 ]; then 
825     CROP=""
826   else 
827     CROP=",crop=$CROP"
828   fi
829   echo "   Setting mencoder crop filter to: $CROP"
830 }
831
832 function get_audio_id_from_vob {
833   # Adjust our audio ID to find the english audio stream
834   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
835   vob="$1"
836   aidcheck=`tempfile`
837   aid=128
838   mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
839   grep -q "Found audio stream: $aid" $aidcheck
840   while [ $? == 1 ] && [ $aid -lt 159 ]; do
841     (( aid = aid + 1 ))
842     grep -q "Found audio stream: $aid" $aidcheck
843   done
844   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
845   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
846   # mencoder default DVD audio track language selection (english)
847   lang_opts="-aid $aid -alang en"
848 }
849
850 function check_vob_for_corrupted_start {
851   # check to see if the beginning of the DVD has a form of copy protection
852   # where they have deliberately broken the first X number of frames of the DVD.
853   # If we don't skip these, our resulting VOB file will not play.
854   badvobcheck=`tempfile`
855   endpos=360
856   skip=0
857   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
858   if [ $? != 0 ]; then
859     fatal_and_exit "-E- Mencoder Failed"
860   fi
861   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
862   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
863     (( skip = skip + 5 ))
864     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
865     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
866     if [ $? != 0 ]; then
867       fatal_and_exit "-E- Mencoder Failed"
868     fi
869     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
870   done
871   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
872
873   # cat the giant VOB into mencoder to create a playable VOB file
874   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
875   if [ $? != 0 ]; then
876     fatal_and_exit "-E- Mencoder Failed"
877   fi
878 }
879
880 function check_vob_for_completeness {
881   # check to make sure we got out a complete VOB.
882   # there is another kind of copy protection where the VOB's may
883   # have "MPG EOF" frames in the middle of the stream. 
884   # this causes mencoder to not process the entire VOB, and exit without any errors.
885   # detect this by seeing how much smaller the dst vob is from the src vob.
886   MAX_FILESIZE_DELTA_PERCENT=70
887   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
888   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
889   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
890   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
891     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
892     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
893     create_main_vob_with_mplayer "$isofile"
894     [[ -e "$dumplog" ]] && rm -f $dumplog
895     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
896     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
897     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
898       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
899     fi
900   fi
901 }
902
903 function check_vob_for_too_many_video_packets {
904   # If our earlier algorithm to work around this failed, throw an error.
905   # check to see if this DVD has a protection scheme we don't know how to work around
906   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
907   # for some reason, the video is black, while the audio rolls, then the video finally comes
908   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
909   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
910   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
911   grep -q "Too many video packets in the buffer:" "$logfile"
912   if [ $? == 0 ]; then
913     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
914     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
915     create_main_vob_with_mplayer "$isofile"
916     grep -q "Too many video packets in the buffer:" $dumplog
917     if [ $? == 0 ]; then
918       [[ -e "$dumplog" ]] && rm -f $dumplog
919       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
920     fi
921     [[ -e "$dumplog" ]] && rm -f $dumplog
922   fi
923 }
924
925 function check_vob_for_a52_crc_errors {
926   # Let's see if we can playback our newly created VOB file without any errors.
927   # if there are issues, let's detect them now, and try to recreate the VOB
928   # there are some forms of copy protection that have missed above, that evidence
929   # themselves when we try to playback the VOB file. This was added to deal with
930   # the "a52: CRC check failed" copy protection scheme.
931   MAX_ERRORS=10
932   ENDPOS=120
933   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
934   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
935   cat $dumplog | grep -v "^A:" >> "$logfile"
936   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
937   if [ $errors -gt $MAX_ERRORS ]; then
938     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
939     create_main_vob_with_mplayer "$isofile"
940     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
941     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
942     if [ $? != 0 ]; then
943       cat $dumplog | grep -v "^A:" >> "$logfile"
944       fatal_and_exit "-E- Mplayer Failed"
945     fi
946     cat $dumplog | grep -v "^A:" >> "$logfile"
947     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
948     if [ $errors -gt $MAX_ERRORS ]; then
949       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
950     fi
951   fi
952   [[ -e "$dumplog" ]] && rm -f $dumplog
953 }
954
955 function calculate_bitrate_from_target_size {
956   # determine what our bitrate needs to be if a target size was specified instead
957   if [ $target_size -ne 0 ]; then
958     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
959     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
960     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
961   fi
962 }
963
964 function create_dvdauthor_dvd_xml_file {
965   # make a dvdauthor xml menu file to create a valid DVD video from 
966   # this script does a good job, but we'll still need to clean it up a bit after it runs
967   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
968   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
969   if [ $? != 0 ]; then
970     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
971   fi
972
973   # replace the first line of the xml file to remove the bad dest path
974   awk -v line=1 -v new_content="<dvdauthor>" '{
975     if (NR == line) {
976       print new_content;
977     } else {
978       print $0;
979     }
980   }' dvd.xml > dvd.xml.new
981   mv -f dvd.xml.new dvd.xml
982   if [ $? != 0 ]; then
983     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
984   fi
985
986   # remove the "<video " property line from the xml file
987   cat dvd.xml | grep -v "<video" > dvd.xml.new
988   mv -f dvd.xml.new dvd.xml
989   if [ $? != 0 ]; then
990     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
991   fi
992   
993   # remove the extra <pgc>..</pgc> pairs
994   cat dvd.xml | awk 'BEGIN {x=1}
995   {
996     if ($0~"</pgc>") {x=0}
997     if (x==1) {print $0}
998     if ($0~"<pgc>") {x=1}
999   }' > dvd.xml.new
1000   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
1001   mv -f dvd.xml.new dvd.xml
1002   if [ $? != 0 ]; then
1003     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1004   fi
1005
1006   # remove the VTS_*_0.VOB file as this is just the main menu video clip
1007   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
1008   mv -f dvd.xml.new dvd.xml
1009   if [ $? != 0 ]; then
1010     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1011   fi
1012 }
1013
1014 function check_for_mplayer_dumpstream_incompatibility {
1015
1016   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
1017
1018   if [ ! -e "$vobfile" ]; then
1019     # mplayer dumpstream does not work on DVDs that obscure the feature title.
1020     # A DVD that has 99 titles, where the longest title isn't the main feature
1021     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
1022     # out what the feature title is. This script will run through that flow if we
1023     # set use_mplayer_dumpstream to 0. Check for this here.
1024     if [ $ripdvd -eq 1 ]; then
1025       lsdvd $dev | grep -q "Title: 99"
1026     else
1027       lsdvd "$isofile" | grep -q "Title: 99"
1028     fi
1029     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
1030     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
1031       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
1032         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
1033         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1034         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
1035         invalid_feature_title=1
1036       else 
1037         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
1038         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1039         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1040         use_mplayer_dumpstream=0
1041         invalid_feature_title=1
1042       fi
1043       return
1044     fi
1045   fi
1046
1047   # There is another form of protection that causes the mplayer dumpstream to fail. 
1048   # This can be detected by telling mplayer to parse the VOB file by copying its audio
1049   # video streams to a dummy output file (/dev/null). Do that here to check for that 
1050   # problem before continuing.
1051   if [ -e "$vobfile" ]; then
1052     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1053     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1054     grep -q "Too many audio packets in the buffer" $dumplog
1055     if [ $? == 0 ]; then
1056       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1057       use_mplayer_dumpstream=0
1058       mplayer_dumpstream_incompatibility=1
1059     fi
1060     [[ -e "$dumplog" ]] && rm -f $dumplog
1061   fi
1062 }
1063
1064 function fill_mythvideo_metadata {
1065
1066   # This function must be passed the filename as an argument
1067   # The filename must be a full path to the file
1068   filename="$1"
1069
1070   # Make sure the fill mythvideo metadata option has been set to 1
1071   if [ $fill_mythvideo_metadata -eq 0 ]; then
1072     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1073     return 0
1074   fi
1075
1076   # If the fill mythvideo metadata script is present, run it
1077   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1078   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1079     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1080     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1081   else
1082     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1083     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1084   fi
1085 }
1086
1087 # remove the intermediate VOB file
1088 function remove_intermediate_vob_file {
1089   if [ $keep_intermediate_files -eq 0 ]; then
1090     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1091   else
1092     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1093   fi
1094 }
1095
1096 # remove the original DVD image 
1097 function remove_intermediate_iso_file {
1098   [[ $keep_isofile -eq 1 ]] && return 1
1099   if [ $keep_intermediate_files -eq 0 ]; then
1100     [[ -e "$isofile" ]] && rm "$isofile"
1101   else
1102     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1103   fi
1104 }
1105
1106 # remove the intermediate dvdbackup folder
1107 function remove_intermediate_dvdbackup_folder {
1108   if [ $keep_intermediate_files -eq 0 ]; then
1109     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1110   else
1111     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1112   fi
1113 }
1114
1115 ##############################################################################################
1116 # MAIN
1117 ##############################################################################################
1118
1119 # Make a note of when this DVD rip started
1120 date=`date`
1121 echo -e "\n$date DVD rip started" >> "$logfile"
1122 echo "$cmd" >> "$logfile"
1123
1124 # Rip the DVD - Mirror Mode
1125 if [ $mirror_mode -eq 1 ]; then
1126   echo "-> Ripping DVD $dvdname to $dest"
1127
1128   # use ddrescue to make an ISO image of the disk
1129   make_dvd_iso_image "$dest/$dvdname.iso"
1130
1131   # add this video data to the mythtv DB
1132   fill_mythvideo_metadata "$dest/$dvdname.iso" 
1133
1134   # eject the disk upon completion
1135   if [ $eject_disk -ne 0 ]; then
1136     eject -T $dev
1137   fi
1138
1139   date=`date`
1140   echo "$date DVD rip completed" | tee -a "$logfile"
1141
1142   if [[ -n "$mailto" ]]; then
1143     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1144   fi
1145
1146 fi
1147
1148 # Rip the DVD - Main Title Feature Only
1149 if [ $mirror_mode -eq 0 ]; then
1150
1151   # Rip image from DVD
1152   if [ $ripdvd -eq 1 ]; then
1153     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1154     # use ddrescue to make an ISO image of the disk
1155     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1156   fi
1157
1158   # Rip image from DVD path
1159   if [ -n "$dvdpath" ]; then
1160     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1161     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1162   fi
1163
1164   # make sure our isofile value is set
1165   if [ -z "$isofile" ]; then
1166     isofile="$tmpdir/$dvdname.iso"
1167   fi
1168      
1169   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1170
1171     if [ ! -e "$vobfile" ]; then
1172       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1173       
1174       # get the feature title from the ISO
1175       get_feature_title "$isofile"
1176  
1177       # get the crop value from the ISO
1178       get_crop_from_iso
1179
1180       # check for mplayer dumpstream incompatibilities
1181       # if they exist, this method will set this mode to 0.
1182       check_for_mplayer_dumpstream_incompatibility
1183
1184       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1185
1186         # get our audio id from the ISO file
1187         get_audio_id_from_iso "$isofile"
1188
1189         # create our main VOB file from the ISO
1190         create_main_vob_with_mplayer "$isofile"
1191      
1192         # remove the intermediate VOB file
1193         remove_intermediate_vob_file
1194
1195         # it's possible that our VOB is still corrupted in some manner
1196         # check to make sure it is still a good VOB before continuing.
1197         check_for_mplayer_dumpstream_incompatibility
1198
1199       fi
1200  
1201       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1202
1203         # use dvdbackup to make a DVD folder of the feature title
1204         make_dvdbackup_folder_image
1205   
1206         # create our main VOB file
1207         create_main_vob_with_cat
1208
1209         # get our audio id from the VOB file
1210         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1211   
1212         # check for corrupted VOB start
1213         check_vob_for_corrupted_start
1214  
1215         # check to make sure our VOB is complete
1216         check_vob_for_completeness
1217
1218         # check to make sure our VOB doesn't have too many video packets
1219         check_vob_for_too_many_video_packets
1220
1221         # check to make sure our VOB doesn't have a52 crc errors
1222         check_vob_for_a52_crc_errors
1223
1224         # remove the intermediate VOB file
1225         remove_intermediate_vob_file
1226
1227       fi
1228
1229       # remove the intermediate ISO file
1230       remove_intermediate_iso_file
1231
1232     else
1233       echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1234       # get our audio id from the VOB file
1235       get_audio_id_from_vob "$vobfile"
1236       # get the crop value from the VOB
1237       get_crop_from_vob
1238     fi
1239
1240     # eject the DVD disk since we are finished with it
1241     [ $eject_disk -eq 2 ] && eject -T $dev
1242
1243     # encode the VOB file to a compressed file format
1244     if [ $make_final_dest_comp -eq 1 ]; then
1245       echo "-> Encoding the DVD video to a compressed file" | tee -a "$logfile"
1246
1247       # determine what our bitrate needs to be if a target size was specified instead
1248       calculate_bitrate_from_target_size        
1249      
1250       # encode the vob file into a compressed file format
1251       encode_vob_file
1252
1253       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1254         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1255         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1256       else
1257         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1258         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1259       fi
1260     fi
1261
1262   # add this video data to the mythtv DB
1263   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1264   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1265     
1266   else
1267
1268   # use dvdbackup to make a DVD folder of the feature title
1269   make_dvdbackup_folder_image
1270
1271   # cd to the feature title DVD folder
1272   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1273   if [ $? != 0 ]; then
1274     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1275   fi
1276   
1277   # create the dvd.xml file for dvdauthor
1278   create_dvdauthor_dvd_xml_file  
1279
1280   # make the final DVD folder image
1281   make_dvdauthor_folder_image
1282
1283   # add this video data to the mythtv DB
1284   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1285  
1286   # cd back to the dir we started from
1287   popd > /dev/null 2>&1
1288
1289   if [ $make_final_dest_iso -eq 1 ]; then
1290
1291     # make an iso image out of our directory
1292     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1293    
1294     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1295     if [ -s "$dest/$dvdname.iso" ]; then
1296       if [ $make_final_dest_folder -eq 0 ]; then
1297         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1298         # remove the folder of the DVD image now that we have a .iso version of it
1299         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1300       fi
1301     else
1302       # we created an empty iso file, remove it
1303       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1304       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1305       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1306     fi
1307  
1308     # add this video data to the mythtv DB
1309     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1310
1311   fi
1312
1313   fi
1314
1315   # remove the ddrescue DVD ISO image
1316   remove_intermediate_iso_file
1317
1318   # remove the tmp dvdbackup folder of the DVD image
1319   remove_intermediate_dvdbackup_folder
1320
1321   # eject the DVD disk upon completion
1322   [ $eject_disk -eq 1 ] && eject -T $dev
1323
1324   date=`date`
1325   echo "$date DVD rip completed" | tee -a "$logfile"
1326
1327   if [[ -n "$mailto" ]]; then
1328     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1329   fi
1330
1331 fi
1332
1333 ##############################################################################################